#include "database/database_util.h"

struct CPDijkNode_;

typedef struct CPDijkNode_
{
    struct CPDijkNode_ *from;
    DBNode* node;
    double val;
    bool marked;

} CPDijkNode;

struct CPTreeNode_;

typedef struct CPTreeNode_
{
    struct CPTreeNode_* father;
    struct CPTreeNode_* leq;
    struct CPTreeNode_* gt;
    double key;
    CPDijkNode* node;

} CPTreeNode;

int CPdestroyTN(CPTreeNode*);

typedef struct CPPrioQueue_
{
    CPTreeNode* root;
    CPTreeNode* top;
    long size;
} CPPrioQueue;

int CPinitPQ(CPPrioQueue*);
CPPrioQueue* CPnewPQ();
int CPendPQ(CPPrioQueue*);
int CPdestroyPQ(CPPrioQueue*);
int CPinsertPQ(CPPrioQueue*,CPDijkNode*, double);
CPDijkNode* CPpopTop(CPPrioQueue*);
